﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Controls;

namespace SLAppTest1
{
	public partial class Page : UserControl
	{
		public static TreeAreaDataSource5 observableStorage = null;

		public Page()
		{
			InitializeComponent();
		}

		private void Button_Click_Add_Node_to_first_root(object sender, System.Windows.RoutedEventArgs e)
		{
			if (Page.observableStorage.Count > 0)
			{
				Page.observableStorage[0].battery.Add(new Battery("new battery"));
			}
		}

		private void Button_Click_Dell_Node_from_first_root(object sender, System.Windows.RoutedEventArgs e)
		{
			if (Page.observableStorage.Count > 0 &&
				Page.observableStorage[0].battery.Count > 0)
			{
				Page.observableStorage[0].battery.RemoveAt(Page.observableStorage[0].battery.Count - 1);
			}
		}

		private void Button_Click_Add_One_Node(object sender, System.Windows.RoutedEventArgs e)
		{
			Page.observableStorage.Add(new TreeArea("A new Node"));
		}

		private void Button_Click_Dell_Last_Node(object sender, System.Windows.RoutedEventArgs e)
		{
			if( Page.observableStorage.Count > 0)
			{
				Page.observableStorage.RemoveAt(Page.observableStorage.Count - 1);
			}
		}
	}

	public class TreeArea
	{
		public TreeArea(string name)
		{
			Name = name;
			ID = string.Empty;
			battery = new ObservableCollection<Battery>();
		}
		public string Name { get; set; }
		public string ID { get; set; }
		public ObservableCollection<Battery> battery { get; set; }
	}
	public class Battery
	{
		public Battery(string name)
		{
			Name = name;
			ID = string.Empty;
			well = new List<Well>();
		}
		public string Name { get; set; }
		public string ID { get; set; }
		public List<Well> well { get; set; }
	}
	public class Well
	{
		public Well(string name)
		{
			Name = name;
			ID = string.Empty;
		}
		public string Name { get; set; }
		public string ID { get; set; }
	}
	public class TreeAreaDataSource5 : ObservableCollection<TreeArea>
	{
		public TreeAreaDataSource5()
		{
			TreeArea treeArea;
			Battery d;
			Add(treeArea = new TreeArea("TreeArea A"));
			treeArea.battery.Add((d = new Battery("battery A-A")));
			d.well.Add(new Well("well I A-A"));
			d.well.Add(new Well("well II A-A"));
			d.well.Add(new Well("well III A-A"));
			d.well.Add(new Well("well IV A-A"));
			d.well.Add(new Well("well V A-A"));
			treeArea.battery.Add((d = new Battery("battery A-B")));
			d.well.Add(new Well("well Blue A-B"));
			d.well.Add(new Well("well Red A-B"));
			d.well.Add(new Well("well Yellow A-B"));
			d.well.Add(new Well("well Green A-B"));
			d.well.Add(new Well("well Orange A-B"));
			treeArea.battery.Add((d = new Battery("battery A-C")));
			d.well.Add(new Well("well East A-C"));
			d.well.Add(new Well("well West A-C"));
			d.well.Add(new Well("well North A-C"));
			d.well.Add(new Well("well South A-C"));
			Add(treeArea = new TreeArea("TreeArea B"));
			treeArea.battery.Add((d = new Battery("battery B-A")));
			d.well.Add(new Well("well 1 B-A"));
			d.well.Add(new Well("well 2 B-A"));
			d.well.Add(new Well("well 3 B-A"));
			d.well.Add(new Well("well 4 B-A"));
			d.well.Add(new Well("well 5 B-A"));
			treeArea.battery.Add((d = new Battery("battery B-B")));
			d.well.Add(new Well("well Diamond B-B"));
			d.well.Add(new Well("well Heart B-B"));
			d.well.Add(new Well("well Club B-B"));
			d.well.Add(new Well("well Spade B-B"));
			treeArea.battery.Add((d = new Battery("battery B-C")));
			d.well.Add(new Well("well Alpha B-C"));
			d.well.Add(new Well("well Beta B-C"));
			d.well.Add(new Well("well Gamma B-C"));
			d.well.Add(new Well("well Delta B-C"));
			d.well.Add(new Well("well Epsilon B-C"));

			Page.observableStorage = this;
		}
	}
}
